<template>
  <div class="settings-container">
    <div class="settings-row">
      <div class="settings-row__item --left">
        <div class="title">FTL гор. доставка</div>
        <ObInput
          :value="getValue('ftlUrban')"
          label="Обобщённая наценка"
          placeholder="—"
          sub-title="%"
          type="money:1"
          :is-convert-money="false"
          @blur="onBlurField('ftlUrban', $event)"
        />
      </div>
      <div class="settings-row__item --right">
        <div class="title">Магистралка контейнеры</div>
        <ObInput
          :value="getValue('mainlineContainer')"
          label="Обобщённая наценка"
          placeholder="—"
          sub-title="%"
          type="money:1"
          :is-convert-money="false"
          @blur="onBlurField('mainlineContainer', $event)"
        />
      </div>
    </div>
    <div class="settings-row">
      <div class="settings-row__item --left">
        <div class="title">FTL межгород</div>
        <ObInput
          :value="getValue('ftlInterurban')"
          label="Обобщённая наценка"
          placeholder="—"
          sub-title="%"
          type="money:1"
          :is-convert-money="false"
          @blur="onBlurField('ftlInterurban', $event)"
        />
      </div>
      <div class="settings-row__item --right">
        <div class="title">Магистралка вагоны</div>
        <ObInput
          :value="getValue('mainlineRail')"
          label="Обобщённая наценка"
          placeholder="—"
          sub-title="%"
          type="money:1"
          :is-convert-money="false"
          @blur="onBlurField('mainlineRail', $event)"
        />
      </div>
    </div>
    <div class="settings-row">
      <div class="settings-row__item --left">
        <div class="title">FTL международные автоперевозки</div>
        <ObInput
          :value="getValue('ftlInternational')"
          label="Обобщённая наценка"
          placeholder="—"
          sub-title="%"
          type="money:1"
          :is-convert-money="false"
          @blur="onBlurField('ftlInternational', $event)"
        />
      </div>
      <div class="settings-row__item --right">
        <div class="title">Заказы “Отправить груз” для значений БЦ с полным доверием</div>
        <ObInput
          :value="getValue('fullTrustOrder')"
          label="Обобщённая наценка"
          placeholder="—"
          sub-title="%"
          type="money:1"
          :is-convert-money="false"
          @blur="onBlurField('fullTrustOrder', $event)"
        />
      </div>
    </div>
    <div class="settings-row">
      <div class="settings-row__item --left">
        <div class="title">Мультимодальные автоплечи</div>
        <ObInput
          :value="getValue('multimodalAuto')"
          label="Обобщённая наценка"
          placeholder="—"
          sub-title="%"
          type="money:1"
          :is-convert-money="false"
          @blur="onBlurField('multimodalAuto', $event)"
        />
      </div>
      <div class="settings-row__item --right">
        <div class="title">Заказы “Отправить груз” для значений БЦ с частичным доверием</div>
        <ObInput
          :value="getValue('partialTrustOrder')"
          label="Обобщённая наценка"
          placeholder="—"
          sub-title="%"
          type="money:1"
          :is-convert-money="false"
          @blur="onBlurField('partialTrustOrder', $event)"
        />
      </div>
    </div>
  </div>
</template>

<script>
import ObInput from 'common-components/src/obComponents/obInput'
import { mapGetters, mapActions } from 'vuex'

const minValue = -25
const maxValue = 100

export default {
  name: 'ClicarSettingsMarkupForAll',
  components: {
    ObInput
  },
  computed: {
    ...mapGetters({
      currentSettings: 'clicarSettings_3/currentSettings'
    }),
  },
  methods: {
    ...mapActions({
      setSettingValue: 'clicarSettings_3/setSettingValue'
    }),
    onBlurField (key, event) {
      let value = event.target.value?.replace(',', '.')

      if (value < minValue) {
        value = minValue
      }
      if (value > maxValue) {
        value = maxValue
      }

      if (value !== this.currentSettings[key]) {
        this.setSettingValue({ path: key, value })
      }
    },
    getValue (key) {
      return this.currentSettings[key] || null
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.settings-row {
  display: flex;
  &__item {
    &.--left {
      width: 320px;
    }
    &.--right {
      flex-grow: 2;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 10px;
      @include font-mixin(16px, 20px, 700, $color-text-base, .4px);
    }
    &::v-deep {
      .ob-input-container {
        margin-top: 10px;
        width: 180px;
      }
    }
  }
}
</style>